import { enableMapSet, freeze, produce } from 'immer';
import { useState, useCallback } from 'react';
enableMapSet();
export function useImmer(initialValue) {
    const [value, updateValue] = useState(() => freeze(typeof initialValue === 'function' ? initialValue() : initialValue, true));
    const setValue = useCallback((updater) => {
        if (typeof updater === 'function')
            updateValue(produce(updater));
        else
            updateValue(freeze(updater));
    }, []);
    return [value, setValue];
}
