import { isString, isUndefined } from 'lodash';
import { useRef, useState } from 'react';
import { useIsomorphicLayoutEffect } from './useIsomorphicLayoutEffect';
export function useRefExtra(refExtra, update) {
    const [, setInstance] = useState(null);
    const ref = useRef(null);
    // eslint-disable-next-line react-hooks/exhaustive-deps
    useIsomorphicLayoutEffect(() => {
        if (!isUndefined(refExtra)) {
            ref.current = isString(refExtra) ? document.querySelector(refExtra) : refExtra();
        }
        if (update) {
            setInstance(ref.current);
        }
    });
    return ref;
}
